package de.ivu.elect.presentation.stimmeingabe.action;

import javax.annotation.Nonnull;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gebietsbaum.boundary.GebietSessionSelect;
import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.stimmeingabe.entity.StimmeingabeHochgerechnet;
import de.ivu.elect.presentation.gruppe.GruppeKumulierteStimmenSearchView;
import de.ivu.elect.presentation.menu.AbstractActionEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

@Named(StimmeingabeHochgerechnetErgebnisAction.COMPONENT_NAME)
public class StimmeingabeHochgerechnetErgebnisAction extends AbstractActionEntry<StimmeingabeHochgerechnet> {

  public static final String COMPONENT_NAME = "stimmeingabeHochgerechnetErgebnisAction";

  private static final long serialVersionUID = 1L;

  @Inject
  private GebietSessionSelect gebietSessionSelect;

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.ERGEBNIS_KUMULIERTE_STIMMEN_ANZEIGEN;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  protected boolean isFireChangeEvent() {
    return false;
  }

  @Override
  protected String doIt(StimmeingabeHochgerechnet entity) {
    if (entity == null) {
      return null;
    }
    Gebiet gebiet = entity.getGebiet();
    if (gebiet == null) {
      return null;
    }

    gebietSessionSelect.setEntity(gebiet);

    return GruppeKumulierteStimmenSearchView.VIEW_ID;
  }

  @Override
  protected void fireChangeEvent() {
    // nichts zu tun
  }

  @Override
  public boolean isDisabledInternal(@Nonnull StimmeingabeHochgerechnet entity) {
    return false;
  }

  @Override
  public String getLabelKey() {
    return "stimmeingabe.auffaelligkeit.ergebnis.menu.item.label";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconCalculate();
  }
}
